module RND_Extensions

	module RND_Resballiza

		class Resballiza
			@@model = Sketchup.active_model
			@@path = File.dirname(__FILE__) # this plugin's folder
			@@rnd_resballiza = "intro1.html"
			@@resballiza_dlg = nil

			def initialize()
			
				@entities = {}
				@falling = 0 ; 
				@resballiza_1_file =  File.join(@@path, @@rnd_resballiza) 
				
				if (!@resballiza_1_file) then
					UI.messagebox("Cannot find file '#{@@rnd_resballiza} in folder '#{@@path}'")
					return
				end

				if @@resballiza_dlg == nil
					@@resballiza_dlg = UI::WebDialog.new("Resballiza v.1.0.2", false, "Resballiza v.1.0.2", 550, 550, 70, 95, true)
					@@resballiza_dlg.add_action_callback("push_frame") do |d,p|
						push_frame(d,p)
					end
				end
			
				@@resballiza_dlg.set_size(550, 550) 
				@@resballiza_dlg.set_file(@resballiza_1_file)
				@@resballiza_dlg.show() ; 
			
			end #def

			
			def push_frame(dialog,data)
				params = query_to_hash(data)   # parse state information
				entity = find_entity_by_name(params['name'])
				entity.transform! entity.transformation.inverse
=begin				
				# -------------------------------------------------------------------------
				# See if rotation is needed 
				# -------------------------------------------------------------------------
				
				target_rotz = params['rotz'].to_f  
				radians = target_rotz ;
				new_rotz = Geom::Transformation.rotation entity.transformation.origin, entity.transformation.zaxis, radians
				entity.transform! new_rotz
=end
				# -------------------------------------------------------------------------
				# variables x, y and z represent ...
				# -------------------------------------------------------------------------

				vector = Geom::Vector3d.new params['x'].to_f, params['y'].to_f, params['z'].to_f
				translation = Geom::Transformation.translation vector
				entity.transform! translation
			
				# -------------------------------------------------------------------------
				# Change the visibility of the Hero components based on the current frame.
				# ------------------------------------------------------------------------- 

				for subentity in entity.definition.entities
					if subentity.definition.name == params['frame']
						subentity.hidden = false
					else
						subentity.hidden = true
					end
				end

			end #def


			def find_entity_by_name(name)
				if @entities[name] != nil
					return @entities[name]
				else
					for entity in Sketchup.active_model.entities
						if entity.typename == "ComponentInstance"
							if entity.name.to_s == name
								return entity
							end
						end
					end
				end
			end #def


			def unescape(string)
				if string != nil
					string = string.gsub(/\+/, ' ').gsub(/((?:%[0-9a-fA-F]{2})+)/n) do
						[$1.delete('%')].pack('H*')
					end
				end
				return string
			end #def


			def query_to_hash(query)
				param_pairs = query.split('&')
				param_hash = {}
				for param in param_pairs
					name, value = param.split('=')
					name = unescape(name)
					value = unescape(value)
					param_hash[name] = value
				end
				return param_hash
			end #def

		end #class

	end #module

end #module
 
file_loaded( __FILE__ ) 
